<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: tools/ngtoucd/ngtoucd.py Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_ad708b1050ae8d6cbaec86d45edda6ed.html">tools</a>&nbsp;&raquo;&nbsp;<a class="el" href="dir_76609fdfad6f2b1792d1d18c113f9269.html">ngtoucd</a>
  </div>
</div>
<div class="contents">
<h1>ngtoucd.py</h1><a href="ngtoucd_8py.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a><a class="code" href="namespacengtoucd.html">00001</a> <span class="comment">#!/usr/bin/env python</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="stringliteral">&quot;&quot;&quot;</span>
<a name="l00004"></a>00004 <span class="stringliteral">ngtoucd - converts Netgen neutral finite element mesh files</span>
<a name="l00005"></a>00005 <span class="stringliteral">          into unstructured cell data format</span>
<a name="l00006"></a>00006 <span class="stringliteral"></span>
<a name="l00007"></a>00007 <span class="stringliteral">Copyright (c) 2002-2005 Richard Boardman, Hans Fangohr</span>
<a name="l00008"></a>00008 <span class="stringliteral"></span>
<a name="l00009"></a>00009 <span class="stringliteral">ngtoucd is free software; you can redistribute it and/or modify it</span>
<a name="l00010"></a>00010 <span class="stringliteral">under the terms of the GNU General Public License as published by the</span>
<a name="l00011"></a>00011 <span class="stringliteral">Free Software Foundation; either version 2</span>
<a name="l00012"></a>00012 <span class="stringliteral"></span>
<a name="l00013"></a>00013 <span class="stringliteral">ngtoucd is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00014"></a>00014 <span class="stringliteral">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or</span>
<a name="l00015"></a>00015 <span class="stringliteral">FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License</span>
<a name="l00016"></a>00016 <span class="stringliteral">for more details.</span>
<a name="l00017"></a>00017 <span class="stringliteral"></span>
<a name="l00018"></a>00018 <span class="stringliteral">You should have received a copy of the GNU General Public License</span>
<a name="l00019"></a>00019 <span class="stringliteral">along with magpar; if not, write to the Free Software Foundation,</span>
<a name="l00020"></a>00020 <span class="stringliteral">Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA</span>
<a name="l00021"></a>00021 <span class="stringliteral"></span>
<a name="l00022"></a>00022 <span class="stringliteral">This program was designed for magpar, so results may</span>
<a name="l00023"></a>00023 <span class="stringliteral">vary when used with other programs accepting AVS/UCD</span>
<a name="l00024"></a>00024 <span class="stringliteral">as an input file format</span>
<a name="l00025"></a>00025 <span class="stringliteral"></span>
<a name="l00026"></a>00026 <span class="stringliteral">&quot;&quot;&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a><a class="code" href="namespacengtoucd.html#a5115ac16e5999edf3604d36bd725d1d8">00028</a> VERSION=<span class="stringliteral">&quot;0.2&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">import</span> os, string, sys, time
<a name="l00031"></a>00031 
<a name="l00032"></a><a class="code" href="namespacengtoucd.html#a47be0275da1bd4a4bd8eaf1122aedd7d">00032</a> <span class="keyword">def </span><a class="code" href="namespacengtoucd.html#a47be0275da1bd4a4bd8eaf1122aedd7d">readmesh</a>(filename):
<a name="l00033"></a>00033     <span class="stringliteral">&quot;&quot;&quot;This will read the NETGEN neutral mesh &#39;filename&#39; and return</span>
<a name="l00034"></a>00034 <span class="stringliteral">    points, tetrahedra and triangles&quot;&quot;&quot;</span>
<a name="l00035"></a>00035     
<a name="l00036"></a>00036     f = open(filename, <span class="stringliteral">&#39;</span><span class="stringliteral">r&#39;)</span>
<a name="l00037"></a>00037 <span class="stringliteral"></span>
<a name="l00038"></a>00038 <span class="stringliteral">    </span><span class="comment">#################################################################</span>
<a name="l00039"></a>00039     <span class="comment">#</span>
<a name="l00040"></a>00040     <span class="comment"># read the first line to get the number of points</span>
<a name="l00041"></a>00041     <span class="comment">#</span>
<a name="l00042"></a>00042     <span class="comment">#################################################################</span>
<a name="l00043"></a>00043 
<a name="l00044"></a>00044     thisline         = f.readline()
<a name="l00045"></a>00045     number_of_points = int(thisline)
<a name="l00046"></a>00046 
<a name="l00047"></a>00047     <span class="comment">#################################################################</span>
<a name="l00048"></a>00048     <span class="comment">#</span>
<a name="l00049"></a>00049     <span class="comment"># read the points</span>
<a name="l00050"></a>00050     <span class="comment">#</span>
<a name="l00051"></a>00051     <span class="comment">#################################################################</span>
<a name="l00052"></a>00052 
<a name="l00053"></a>00053     points = []
<a name="l00054"></a>00054 
<a name="l00055"></a>00055     <span class="keywordflow">for</span> i <span class="keywordflow">in</span> range(number_of_points):
<a name="l00056"></a>00056         thisline  = f.readline()
<a name="l00057"></a>00057         segments  = string.split(thisline[:-1])
<a name="l00058"></a>00058         thispoint = list(map(<span class="keyword">lambda</span> p: float(p), segments))
<a name="l00059"></a>00059         points.append(thispoint)
<a name="l00060"></a>00060 
<a name="l00061"></a>00061     <span class="comment">#################################################################</span>
<a name="l00062"></a>00062     <span class="comment">#</span>
<a name="l00063"></a>00063     <span class="comment"># now read all the volume elements</span>
<a name="l00064"></a>00064     <span class="comment"># first, ascertain the number of volume elements</span>
<a name="l00065"></a>00065     <span class="comment">#</span>
<a name="l00066"></a>00066     <span class="comment">#################################################################</span>
<a name="l00067"></a>00067 
<a name="l00068"></a>00068     thisline             = f.readline()
<a name="l00069"></a>00069     number_of_tetrahedra = int(thisline)
<a name="l00070"></a>00070 
<a name="l00071"></a>00071     <span class="comment">#################################################################</span>
<a name="l00072"></a>00072     <span class="comment">#</span>
<a name="l00073"></a>00073     <span class="comment"># then read and populate, keeping track</span>
<a name="l00074"></a>00074     <span class="comment"># of the tetrahedra subdomain</span>
<a name="l00075"></a>00075     <span class="comment">#</span>
<a name="l00076"></a>00076     <span class="comment">#################################################################</span>
<a name="l00077"></a>00077     
<a name="l00078"></a>00078     tetrahedra           = []
<a name="l00079"></a>00079     tetrahedra_subdomain = []
<a name="l00080"></a>00080 
<a name="l00081"></a>00081     <span class="keywordflow">for</span> i <span class="keywordflow">in</span> range(number_of_tetrahedra):
<a name="l00082"></a>00082         thisline = f.readline()
<a name="l00083"></a>00083         segments = string.split(thisline[:-1])
<a name="l00084"></a>00084         <span class="keywordflow">if</span> len(segments) != 5:
<a name="l00085"></a>00085             <span class="keywordflow">print</span> <span class="stringliteral">&quot;Found&quot;</span>, len(segments), <span class="stringliteral">&quot;elements, but expected 5&quot;</span>
<a name="l00086"></a>00086             <span class="keywordflow">print</span> segments
<a name="l00087"></a>00087             <span class="keywordflow">raise</span> <span class="stringliteral">&quot;Oops&quot;</span>, <span class="stringliteral">&quot;File format error&quot;</span>
<a name="l00088"></a>00088 
<a name="l00089"></a>00089         tetrahedra_subdomain.append(int(segments[0])-1)
<a name="l00090"></a>00090 
<a name="l00091"></a>00091         <span class="comment"># rpb, 17th March 2006 - updated to handle materials (note:</span>
<a name="l00092"></a>00092         <span class="comment"># in netgen these are top-level objects [tlos])</span>
<a name="l00093"></a>00093         <span class="comment"># original mapping was [a, b, c, d] (where a-d are points)</span>
<a name="l00094"></a>00094         <span class="comment"># new mapping is [[a,b,c,d],m] (where m is a material ID)</span>
<a name="l00095"></a>00095         tetrahedron = [list(map(<span class="keyword">lambda</span> t : int(t)-1, segments[1:5])), int(segments[0])]
<a name="l00096"></a>00096 
<a name="l00097"></a>00097         <span class="comment"># netgen counts from 1 rather than from 0, hence int(t)-1</span>
<a name="l00098"></a>00098 
<a name="l00099"></a>00099         tetrahedra.append(tetrahedron)
<a name="l00100"></a>00100 
<a name="l00101"></a>00101     <span class="comment">#################################################################</span>
<a name="l00102"></a>00102     <span class="comment">#</span>
<a name="l00103"></a>00103     <span class="comment"># now for the surface elements</span>
<a name="l00104"></a>00104     <span class="comment"># ascertain the number of surface elements</span>
<a name="l00105"></a>00105     <span class="comment">#</span>
<a name="l00106"></a>00106     <span class="comment">#################################################################</span>
<a name="l00107"></a>00107 
<a name="l00108"></a>00108     thisline            = f.readline()
<a name="l00109"></a>00109     number_of_triangles = int(thisline)
<a name="l00110"></a>00110     triangles           = []
<a name="l00111"></a>00111     triangles_subdomain = []
<a name="l00112"></a>00112     <span class="keywordflow">for</span> i <span class="keywordflow">in</span> range(number_of_triangles):
<a name="l00113"></a>00113         thisline = f.readline()
<a name="l00114"></a>00114         segments = string.split(thisline[:-1])
<a name="l00115"></a>00115         <span class="keywordflow">if</span> len(segments) != 4:
<a name="l00116"></a>00116             <span class="keywordflow">print</span> <span class="stringliteral">&quot;Found&quot;</span>, len(segments), <span class="stringliteral">&quot;elements, but expected 4&quot;</span>
<a name="l00117"></a>00117             <span class="keywordflow">print</span> segments
<a name="l00118"></a>00118             <span class="keywordflow">raise</span> <span class="stringliteral">&quot;Oops&quot;</span>, <span class="stringliteral">&quot;File format error&quot;</span>
<a name="l00119"></a>00119 
<a name="l00120"></a>00120         triangles_subdomain.append(int(segments[0])-1)
<a name="l00121"></a>00121         <span class="comment"># similar adjustment for materials as with tetrahedra</span>
<a name="l00122"></a>00122         triangle = [list(map(<span class="keyword">lambda</span> t : int(t)-1, segments[1:4])), int(segments[0])]
<a name="l00123"></a>00123         triangles.append(triangle)
<a name="l00124"></a>00124 
<a name="l00125"></a>00125     <span class="comment">#################################################################</span>
<a name="l00126"></a>00126     <span class="comment">#</span>
<a name="l00127"></a>00127     <span class="comment"># send back the read mesh</span>
<a name="l00128"></a>00128     <span class="comment">#</span>
<a name="l00129"></a>00129     <span class="comment">#################################################################</span>
<a name="l00130"></a>00130     
<a name="l00131"></a>00131     <span class="keywordflow">return</span> (points, tetrahedra, triangles, tetrahedra_subdomain, triangles_subdomain)
<a name="l00132"></a>00132 
<a name="l00133"></a><a class="code" href="namespacengtoucd.html#ab91d40cc56868e5898ea2b651eba2b43">00133</a> <span class="keyword">def </span><a class="code" href="namespacengtoucd.html#ab91d40cc56868e5898ea2b651eba2b43">bail</a>(message=&quot;Sorry, I don&#39;t understand. Bailing out...&quot;):
<a name="l00134"></a>00134     <span class="stringliteral">&quot;&quot;&quot;A &#39;get-out&#39; clause&quot;&quot;&quot;</span>
<a name="l00135"></a>00135     <span class="keywordflow">print</span> message
<a name="l00136"></a>00136     sys.exit(1)
<a name="l00137"></a>00137 
<a name="l00138"></a><a class="code" href="namespacengtoucd.html#a72ca942cd9b83f9141ba08e799d21855">00138</a> <span class="keyword">def </span><a class="code" href="namespacengtoucd.html#a72ca942cd9b83f9141ba08e799d21855">initialise_file</a>(file):
<a name="l00139"></a>00139     <span class="stringliteral">&quot;&quot;&quot;Attempt to remove the file first to avoid append issues&quot;&quot;&quot;</span>
<a name="l00140"></a>00140     <span class="keywordflow">try</span>:
<a name="l00141"></a>00141         os.remove(file)
<a name="l00142"></a>00142     <span class="keywordflow">except</span>:
<a name="l00143"></a>00143         <span class="comment"># no problem</span>
<a name="l00144"></a>00144         <span class="keywordflow">pass</span>
<a name="l00145"></a>00145 
<a name="l00146"></a><a class="code" href="namespacengtoucd.html#a0b5d998d3962ed7f06a3e0bc3644fd65">00146</a> <span class="keyword">def </span><a class="code" href="namespacengtoucd.html#a0b5d998d3962ed7f06a3e0bc3644fd65">writeln</a>(line, file):
<a name="l00147"></a>00147     <span class="stringliteral">&quot;&quot;&quot;One-shot file line append; this keeps the code terse&quot;&quot;&quot;</span>
<a name="l00148"></a>00148     f = open(file, <span class="stringliteral">&#39;a&#39;</span>)
<a name="l00149"></a>00149     f.write(line + <span class="stringliteral">&#39;\n&#39;</span>)
<a name="l00150"></a>00150     f.close()
<a name="l00151"></a>00151 
<a name="l00152"></a><a class="code" href="namespacengtoucd.html#aa54a263a1db4eb44f79390e7c5e3708e">00152</a> <span class="keyword">def </span><a class="code" href="namespacengtoucd.html#aa54a263a1db4eb44f79390e7c5e3708e">stamp</a>():
<a name="l00153"></a>00153     <span class="stringliteral">&quot;&quot;&quot;Format a time and a date for stdout feedback&quot;&quot;&quot;</span>
<a name="l00154"></a>00154     thistime = time.localtime()
<a name="l00155"></a>00155     <span class="keywordflow">return</span> <span class="stringliteral">&quot;[%04d/%02d/%02d %02d:%02d:%02d] &quot;</span> % (thistime[0],
<a name="l00156"></a>00156                                                  thistime[1],
<a name="l00157"></a>00157                                                  thistime[2],
<a name="l00158"></a>00158                                                  thistime[3],
<a name="l00159"></a>00159                                                  thistime[4],
<a name="l00160"></a>00160                                                  thistime[5])
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 
<a name="l00163"></a><a class="code" href="namespacengtoucd.html#abdec0ac167bdcd2c6c96ce8910042bce">00163</a> <span class="keyword">def </span><a class="code" href="namespacengtoucd.html#abdec0ac167bdcd2c6c96ce8910042bce">info</a>():
<a name="l00164"></a>00164     <span class="stringliteral">&quot;&quot;&quot;Output GPL details&quot;&quot;&quot;</span>
<a name="l00165"></a>00165     <span class="keywordflow">print</span> <span class="stringliteral">&quot;&quot;&quot;ngtoucd, copyright (c) 2002-2005 Richard Boardman, Hans Fangohr</span>
<a name="l00166"></a>00166 <span class="stringliteral">ngtoucd comes with ABSOLUTELY NO WARRANTY; for details see the file COPYING&quot;&quot;&quot;</span>
<a name="l00167"></a>00167 
<a name="l00168"></a><a class="code" href="namespacengtoucd.html#a03bb5298219d9d9c1c867dfddc633501">00168</a> <span class="keyword">def </span><a class="code" href="namespacengtoucd.html#a03bb5298219d9d9c1c867dfddc633501">writeucd</a>():
<a name="l00169"></a>00169     <span class="stringliteral">&quot;&quot;&quot;Call readmesh to read the NETGEN mesh, then convert and write the UCD mesh&quot;&quot;&quot;</span>
<a name="l00170"></a>00170     info()
<a name="l00171"></a>00171     al = len(sys.argv)
<a name="l00172"></a>00172     <span class="keywordflow">if</span> al &lt; 2 <span class="keywordflow">or</span> al &gt; 3 <span class="keywordflow">or</span> sys.argv[1] == <span class="stringliteral">&#39;--help&#39;</span> <span class="keywordflow">or</span> sys.argv[1] == <span class="stringliteral">&#39;-h&#39;</span>:
<a name="l00173"></a>00173         bail(<span class="stringliteral">&quot;Usage: &quot;</span> + sys.argv[0] + <span class="stringliteral">&quot; neutral.msh [ucdmesh.inp]&quot;</span>)
<a name="l00174"></a>00174 
<a name="l00175"></a>00175     inputfile = sys.argv[1]
<a name="l00176"></a>00176 
<a name="l00177"></a>00177     <span class="keywordflow">if</span> len(sys.argv) == 3:
<a name="l00178"></a>00178         outputfile = sys.argv[2]
<a name="l00179"></a>00179     <span class="keywordflow">else</span>:
<a name="l00180"></a>00180         outputfile = os.path.splitext(inputfile)[0] + <span class="stringliteral">&quot;.inp&quot;</span>
<a name="l00181"></a>00181 
<a name="l00182"></a>00182     <span class="keywordflow">print</span>
<a name="l00183"></a>00183     <span class="keywordflow">print</span> <span class="stringliteral">&quot;About to read, check and process the neutral mesh&quot;</span>, inputfile
<a name="l00184"></a>00184     <span class="keywordflow">print</span> <span class="stringliteral">&quot;and then create the AVS/UCD mesh&quot;</span>, outputfile
<a name="l00185"></a>00185     <span class="keywordflow">print</span>
<a name="l00186"></a>00186 
<a name="l00187"></a>00187     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;Initialising file&quot;</span> + outputfile
<a name="l00188"></a>00188     initialise_file(outputfile)
<a name="l00189"></a>00189     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;File &quot;</span> + outputfile + <span class="stringliteral">&quot; initialised&quot;</span>
<a name="l00190"></a>00190 
<a name="l00191"></a>00191     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;Attemping read of input &quot;</span> + inputfile
<a name="l00192"></a>00192     (points, tetrahedra, triangles, tetrasub, trisub) = readmesh(inputfile)
<a name="l00193"></a>00193     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;Input file successfully read&quot;</span>
<a name="l00194"></a>00194 
<a name="l00195"></a>00195     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;Points:     %d&quot;</span> % len(points)
<a name="l00196"></a>00196     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;Tetrahedra: %d [%d in subdomain]&quot;</span> % (len(tetrahedra), len(tetrasub))
<a name="l00197"></a>00197     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;Triangles:  %d [%d in subdomain]&quot;</span> % (len(triangles),  len(trisub))
<a name="l00198"></a>00198 
<a name="l00199"></a>00199     <span class="comment">#################################################################</span>
<a name="l00200"></a>00200     <span class="comment">#</span>
<a name="l00201"></a>00201     <span class="comment"># the first line of a UCD file reads:</span>
<a name="l00202"></a>00202     <span class="comment"># a b c d e</span>
<a name="l00203"></a>00203     <span class="comment">#</span>
<a name="l00204"></a>00204     <span class="comment"># where a is the number of nodes</span>
<a name="l00205"></a>00205     <span class="comment">#       b is the number of cells</span>
<a name="l00206"></a>00206     <span class="comment">#       c is the length of vector data associated with the nodes</span>
<a name="l00207"></a>00207     <span class="comment">#       d is the length of vector data associated with the cells</span>
<a name="l00208"></a>00208     <span class="comment">#       e is the length of vector data associated with the model</span>
<a name="l00209"></a>00209     <span class="comment">#</span>
<a name="l00210"></a>00210     <span class="comment"># example: 12 2 1 0 0</span>
<a name="l00211"></a>00211     <span class="comment">#</span>
<a name="l00212"></a>00212     <span class="comment">#################################################################</span>
<a name="l00213"></a>00213 
<a name="l00214"></a>00214     <span class="comment"># n.b. here the third integer indicates the number of placeholders</span>
<a name="l00215"></a>00215     
<a name="l00216"></a>00216     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;Creating descriptor [UCD]&quot;</span>
<a name="l00217"></a>00217     writeln(str(len(points)) + <span class="stringliteral">&quot; &quot;</span> + str(len(tetrahedra)) + <span class="stringliteral">&quot; 3 0 0&quot;</span>, outputfile)
<a name="l00218"></a>00218     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;UCD descriptor created&quot;</span>
<a name="l00219"></a>00219     
<a name="l00220"></a>00220     <span class="comment">#################################################################</span>
<a name="l00221"></a>00221     <span class="comment">#</span>
<a name="l00222"></a>00222     <span class="comment"># then we have nodes in threespace, one line per node</span>
<a name="l00223"></a>00223     <span class="comment"># n x y z</span>
<a name="l00224"></a>00224     <span class="comment"># where n is the node ID -- integer (not necessarily sequential)</span>
<a name="l00225"></a>00225     <span class="comment">#       x,y,z are the x, y and z coordinates</span>
<a name="l00226"></a>00226     <span class="comment">#</span>
<a name="l00227"></a>00227     <span class="comment">#################################################################</span>
<a name="l00228"></a>00228 
<a name="l00229"></a>00229     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;Now converting nodes&quot;</span>
<a name="l00230"></a>00230     <span class="keywordflow">for</span> i <span class="keywordflow">in</span> range(len(points)):
<a name="l00231"></a>00231         x, y, z = points[i][0], points[i][1], points[i][2]
<a name="l00232"></a>00232         writeln(str(i+1) + <span class="stringliteral">&quot; &quot;</span> + str(x) + <span class="stringliteral">&quot; &quot;</span> + str(y) + <span class="stringliteral">&quot; &quot;</span> + str(z), outputfile)
<a name="l00233"></a>00233     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;Nodes converted&quot;</span>
<a name="l00234"></a>00234 
<a name="l00235"></a>00235     <span class="comment">#################################################################</span>
<a name="l00236"></a>00236     <span class="comment">#</span>
<a name="l00237"></a>00237     <span class="comment"># now the cells, one line/cell:</span>
<a name="l00238"></a>00238     <span class="comment">#</span>
<a name="l00239"></a>00239     <span class="comment"># c m t n1 n2 ... nn</span>
<a name="l00240"></a>00240     <span class="comment">#</span>
<a name="l00241"></a>00241     <span class="comment"># where c is the cell ID</span>
<a name="l00242"></a>00242     <span class="comment">#       m is the material type (int, leave as 1 if we don&#39;t care)</span>
<a name="l00243"></a>00243     <span class="comment">#       t is the cell type (prism|hex|pyr|tet|quad|tri|line|pt)</span>
<a name="l00244"></a>00244     <span class="comment">#       n1...nn is a node ID list corresponding to cell vertices</span>
<a name="l00245"></a>00245     <span class="comment">#</span>
<a name="l00246"></a>00246     <span class="comment">#################################################################</span>
<a name="l00247"></a>00247 
<a name="l00248"></a>00248     cellctr = 0
<a name="l00249"></a>00249 
<a name="l00250"></a>00250     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;Converting tetrahedra&quot;</span>
<a name="l00251"></a>00251 
<a name="l00252"></a>00252     <span class="comment">### here we need to take extra care of the tetrahedra point write</span>
<a name="l00253"></a>00253     <span class="comment">### order to avoid &quot;negative&quot; volume issues</span>
<a name="l00254"></a>00254 
<a name="l00255"></a>00255     <span class="keywordflow">for</span> tetra <span class="keywordflow">in</span> tetrahedra:
<a name="l00256"></a>00256         tet = tetra[0] <span class="comment"># just the tetrahedron; tetra[1] is the material</span>
<a name="l00257"></a>00257         tetorder  = [0, 2, 1, 3]
<a name="l00258"></a>00258         tetstring =  <span class="stringliteral">&quot; &quot;</span> + str(tet[tetorder[0]]+1)
<a name="l00259"></a>00259         tetstring += <span class="stringliteral">&quot; &quot;</span> + str(tet[tetorder[1]]+1)
<a name="l00260"></a>00260         tetstring += <span class="stringliteral">&quot; &quot;</span> + str(tet[tetorder[2]]+1)
<a name="l00261"></a>00261         tetstring += <span class="stringliteral">&quot; &quot;</span> + str(tet[tetorder[3]]+1)
<a name="l00262"></a>00262         writeln(str(cellctr+1) + <span class="stringliteral">&quot; &quot;</span> + str(tetra[1]) + <span class="stringliteral">&quot; tet&quot;</span> + tetstring, outputfile)
<a name="l00263"></a>00263         cellctr   += 1
<a name="l00264"></a>00264 
<a name="l00265"></a>00265     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;Tetrahedra converted&quot;</span>
<a name="l00266"></a>00266 
<a name="l00267"></a>00267     <span class="comment">#################################################################</span>
<a name="l00268"></a>00268     <span class="comment">#</span>
<a name="l00269"></a>00269     <span class="comment"># uncomment the following section to convert triangles as well</span>
<a name="l00270"></a>00270     <span class="comment"># - since magpar will ignore these, leave away for the time being</span>
<a name="l00271"></a>00271     <span class="comment">#</span>
<a name="l00272"></a>00272     <span class="comment"># print stamp() + &quot;Converting triangles&quot;</span>
<a name="l00273"></a>00273     <span class="comment">#</span>
<a name="l00274"></a>00274     <span class="comment"># cellctr = 0</span>
<a name="l00275"></a>00275     <span class="comment"># for triang in triangles:</span>
<a name="l00276"></a>00276     <span class="comment">#     tri = triang[0] # just the triangle; triang[1] is the material</span>
<a name="l00277"></a>00277     <span class="comment">#     tristring = &quot;&quot;</span>
<a name="l00278"></a>00278     <span class="comment">#     for node in tri:</span>
<a name="l00279"></a>00279     <span class="comment">#         tristring += &quot; &quot; + str(node+1)</span>
<a name="l00280"></a>00280     <span class="comment">#     writeln(str(cellctr+1) + &quot; &quot; + str(triang[1]) + &quot; tri&quot; + ts, outputfile)</span>
<a name="l00281"></a>00281     <span class="comment">#</span>
<a name="l00282"></a>00282     <span class="comment"># print stamp() + &quot;Triangles converted&quot;</span>
<a name="l00283"></a>00283     <span class="comment">#</span>
<a name="l00284"></a>00284     <span class="comment">#################################################################</span>
<a name="l00285"></a>00285 
<a name="l00286"></a>00286     <span class="comment">#################################################################</span>
<a name="l00287"></a>00287     <span class="comment">#</span>
<a name="l00288"></a>00288     <span class="comment"># for the data vector associated with the nodes:</span>
<a name="l00289"></a>00289     <span class="comment">#</span>
<a name="l00290"></a>00290     <span class="comment"># first line tells us into which components the vector is divided</span>
<a name="l00291"></a>00291     <span class="comment">#</span>
<a name="l00292"></a>00292     <span class="comment">#   example: vector of 5 floats could be 3 3 1 1</span>
<a name="l00293"></a>00293     <span class="comment">#            node scalar could be 1 1</span>
<a name="l00294"></a>00294     <span class="comment">#</span>
<a name="l00295"></a>00295     <span class="comment"># next lines, for each data component, use a cs label/unit pair</span>
<a name="l00296"></a>00296     <span class="comment">#</span>
<a name="l00297"></a>00297     <span class="comment">#   example: temperature, kelvin</span>
<a name="l00298"></a>00298     <span class="comment">#</span>
<a name="l00299"></a>00299     <span class="comment"># subsequent lines, for each node, the vector of associated data</span>
<a name="l00300"></a>00300     <span class="comment"># in this order</span>
<a name="l00301"></a>00301     <span class="comment">#</span>
<a name="l00302"></a>00302     <span class="comment">#   example: 1 10\n2 15\n3 12.4\n4 9</span>
<a name="l00303"></a>00303     <span class="comment">#</span>
<a name="l00304"></a>00304     <span class="comment">#################################################################</span>
<a name="l00305"></a>00305 
<a name="l00306"></a>00306     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;Initialising placeholders&quot;</span>
<a name="l00307"></a>00307 
<a name="l00308"></a>00308     writeln(<span class="stringliteral">&quot;3 1 1 1&quot;</span>, outputfile)
<a name="l00309"></a>00309     writeln(<span class="stringliteral">&quot;M_x, none&quot;</span>, outputfile)
<a name="l00310"></a>00310     writeln(<span class="stringliteral">&quot;M_y, none&quot;</span>, outputfile)
<a name="l00311"></a>00311     writeln(<span class="stringliteral">&quot;M_z, none&quot;</span>, outputfile)
<a name="l00312"></a>00312     
<a name="l00313"></a>00313     <span class="comment">#################################################################</span>
<a name="l00314"></a>00314     <span class="comment">#</span>
<a name="l00315"></a>00315     <span class="comment"># create some initial scalar values; here, generally</span>
<a name="l00316"></a>00316     <span class="comment"># +x=1.0 +y=+z=0.01*x (everything else)=&quot;\epsilon&quot;</span>
<a name="l00317"></a>00317     <span class="comment">#</span>
<a name="l00318"></a>00318     <span class="comment">#################################################################</span>
<a name="l00319"></a>00319 
<a name="l00320"></a>00320     scalarstring =  <span class="stringliteral">&quot; 1.0 0.0 0.0&quot;</span>
<a name="l00321"></a>00321 
<a name="l00322"></a>00322     <span class="keywordflow">for</span> i <span class="keywordflow">in</span> range(len(points)):
<a name="l00323"></a>00323         writeln(str(i+1) + scalarstring, outputfile)
<a name="l00324"></a>00324 
<a name="l00325"></a>00325     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;Placeholders inserted&quot;</span>
<a name="l00326"></a>00326 
<a name="l00327"></a>00327     <span class="comment"># all done</span>
<a name="l00328"></a>00328 
<a name="l00329"></a>00329     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;All finished&quot;</span>
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 
<a name="l00332"></a>00332     
<a name="l00333"></a>00333 <span class="keywordflow">if</span> __name__==<span class="stringliteral">&quot;__main__&quot;</span>:
<a name="l00334"></a>00334     writeucd()
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

